#define WIN32_LEAN_AND_MEAN
#define STRICT
#include <windows.h>

#include "ReplaceIAT.h"
#include "dllmain.h"

typedef HDC (WINAPI *PFNBEGINPAINT)(HWND hWnd, LPPAINTSTRUCT lpPaint);
inline  HDC orig_BeginPaint(HWND hWnd, LPPAINTSTRUCT lpPaint)
{ return ((PFNBEGINPAINT) GetProcAddrMod("user32.dll",BeginPaint))(hWnd,lpPaint);}

typedef HDC (WINAPI *PFNGETDC)(HWND);
inline  HDC orig_GetDC(HWND hWnd)
{ return ((PFNGETDC) GetProcAddrMod("user32.dll",GetDC))(hWnd); }

typedef BOOL (WINAPI *PFNMOVEWINDOW)(HWND hWnd, int X,int Y, int nWidth, int nHeight, BOOL bRepaint);
inline BOOL orig_MoveWindow(HWND hWnd, int X,int Y, int nWidth, int nHeight, BOOL bRepaint)
{ return ((PFNMOVEWINDOW) GetProcAddrMod( "user32.dll", MoveWindow ))(hWnd, X, Y, nWidth, nHeight, bRepaint); }

typedef SHORT (WINAPI *PFNGETASYNCKEYSTATE)(int vKey);
inline BOOL orig_GetAsyncKeyState(int vKey)
{ return ((PFNGETASYNCKEYSTATE) GetProcAddrMod( "user32.dll", GetAsyncKeyState ))(vKey); }


HWND g_hWnd = NULL;

// BeginPaint tbN
HDC WINAPI Hook_BeginPaint(HWND hWnd, LPPAINTSTRUCT lpPaint)
{
	HDC hDc = orig_BeginPaint(hWnd, lpPaint);
	if(hWnd == g_hWnd)
	{
		SetMapMode(hDc, MM_ANISOTROPIC);
		SetViewportExtEx(hDc, WINX, WINY, NULL);
		SetWindowExtEx(hDc, 320,240, NULL);
	}
	return hDc;    
}

// GetDC tbN
HDC WINAPI Hook_GetDC(HWND hWnd)
{
	HDC hDc = orig_GetDC(hWnd);
	if(hWnd == g_hWnd)
	{
		SetMapMode(hDc, MM_ANISOTROPIC);
		SetViewportExtEx(hDc, WINX, WINY, NULL);
		SetWindowExtEx(hDc, 320,240, NULL);
	}
	return hDc;
}

// MoveWindow tbN
BOOL WINAPI Hook_MoveWindow(HWND hWnd, int X,int Y, int nWidth, int nHeight, BOOL bRepaint)
{
	if(hWnd == g_hWnd) return TRUE;
	return orig_MoveWindow(hWnd, X, Y, nWidth, nHeight, bRepaint);
}

// GetAsyncKeyState tbN
SHORT WINAPI Hook_GetAsyncKeyState(int vKey)
{
	if(vKey == 'X') vKey = 'Z';
	else if(vKey == 'Z') vKey = 'X';
	return orig_GetAsyncKeyState(vKey);
}


// 𑜓x؂ւ
BOOL FullScreen(BOOL bFullScreen)
{
	if(bFullScreen)
	{
		DEVMODE d;
		d.dmSize = sizeof(DEVMODE);
		d.dmPelsWidth = WINX;
		d.dmPelsHeight = WINY;
		d.dmFields = DM_PELSWIDTH | DM_PELSHEIGHT;
		if(ChangeDisplaySettings(&d, CDS_FULLSCREEN) == DISP_CHANGE_SUCCESSFUL)
		{
			ShowCursor(FALSE);
			return TRUE;
		}
	}
	else
	{
		ShowCursor(TRUE);
		ChangeDisplaySettings(NULL, 0);
	}
	return FALSE;
}

WNDPROC g_OrgWndProc = NULL;

// [hgO
BOOL ChangeFullScreen(BOOL bFullScreen)
{
	HWND hWnd = g_hWnd;
	static RECT rectWindow = {0,0,0,0};
	if(bFullScreen)
	{
		GetWindowRect(g_hWnd, &rectWindow);
		rectWindow.right-=rectWindow.left;
		rectWindow.bottom-=rectWindow.top;

		if( FullScreen(TRUE) == FALSE ) return FALSE;
		SetWindowLong(g_hWnd, GWL_STYLE, FULLSCREENWINDOWSTYLE);
		orig_MoveWindow(hWnd, 0, 0, WINX, WINY, TRUE);
		return TRUE;
	}
	else
	{
		FullScreen(FALSE);
		SetWindowLong(g_hWnd, GWL_STYLE, DEFAULTWINDOWSTYLE);
		orig_MoveWindow(hWnd, rectWindow.left, rectWindow.top, rectWindow.right, rectWindow.bottom, TRUE);
	}
	return FALSE;
}


BOOL SaveFullScreenMode(BOOL bFullScreen)
{
	HANDLE hFile;
	DWORD dw;
	hFile = CreateFile( TEXT("mg.cff"), GENERIC_WRITE, NULL, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE) return FALSE;
	WriteFile(hFile, &bFullScreen, 1, &dw, NULL);
	CloseHandle(hFile);
	return TRUE;
}

BOOL LoadFullScreenMode()
{
	HANDLE hFile;
	BOOL bFullScreen = 0;
	DWORD dw;
	hFile = CreateFile( TEXT("mg.cff"), GENERIC_READ, NULL, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE) return FALSE;
	ReadFile(hFile, &bFullScreen, 1, &dw, NULL);
	CloseHandle(hFile);
	return bFullScreen;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static BOOL bFullScreen = FALSE;
	switch(uMsg)
	{

	case WM_SETFULLSCREENMODE:
		if(wParam)
			bFullScreen = ChangeFullScreen(TRUE);
		return 0;


	case WM_ACTIVATE:
		if(! bFullScreen) break;

		if(wParam != WA_INACTIVE){
			FullScreen(TRUE);
			ShowWindow(hWnd, SW_SHOW);
		}
		else{
			FullScreen(FALSE);
			ShowWindow(g_hWnd, SW_MINIMIZE);
		}
		break;

	case WM_SYSCHAR:
		if(wParam == '\r'){ // Alt+EnterŃgO
			bFullScreen ^= TRUE;
			bFullScreen = ChangeFullScreen(bFullScreen);
			return 0;
		}
		break;

	case WM_SYSCOMMAND:
		if(wParam == SC_MAXIMIZE){ // ő剻{^
			bFullScreen = ChangeFullScreen(TRUE);
			return 0;
		}
		break;

	case WM_SIZE:
		if(wParam == SIZE_MAXIMIZED){ // LvVo[_uNbN RΉȂႢȂ̂Windows̃oOˁH
			ShowWindow(hWnd, SW_RESTORE);
			bFullScreen = ChangeFullScreen(TRUE);
			return 0;
		}
		break;

	case WM_CHAR:
		if(wParam = 'X') wParam = 'Z';
		else if(wParam = 'Z') wParam = 'X';
		break;

	case WM_DESTROY: // Iɐݒۑ
 		SaveFullScreenMode(bFullScreen != FALSE);
		break;
	}
	return CallWindowProc(g_OrgWndProc, hWnd, uMsg, wParam, lParam);
}


DWORD APIENTRY Main(BOOL bFullScreen)
{

	ReplaceApi( "user32.dll", BeginPaint, Hook_BeginPaint);
	ReplaceApi( "user32.dll", GetDC, Hook_GetDC);
	ReplaceApi( "user32.dll", MoveWindow, Hook_MoveWindow);

	{
		HANDLE hFile = CreateFile(TEXT("ExchangeXZ.txt"), GENERIC_READ,NULL,NULL,OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if(hFile != INVALID_HANDLE_VALUE)
		{
			CloseHandle(hFile);
			ReplaceApi( "user32.dll", GetAsyncKeyState, Hook_GetAsyncKeyState);
		}
	}

	HWND hWnd;
	while(! FindWindow(TEXT("oniwnd0"), TEXT("Moon Goddes") ))
		Sleep(1);

	hWnd = g_hWnd = FindWindow(TEXT("oniwnd0"), TEXT("Moon Goddes"));

	g_OrgWndProc = (WNDPROC) GetWindowLong(hWnd, GWL_WNDPROC);
	SetWindowLong(hWnd, GWL_WNDPROC, (LONG) WndProc);
	SetWindowLong(hWnd, GWL_STYLE, DEFAULTWINDOWSTYLE);

	RECT r;
	GetWindowRect(hWnd, &r);
	int w = r.right-r.left-320+ WINX;
	int h = r.bottom-r.top-240+ WINY;
	orig_MoveWindow(hWnd,r.left-(WINX-320)/2 ,r.top-(WINY-240)/2,w,h,TRUE);

	if( bFullScreen )
		PostMessage(hWnd, WM_SETFULLSCREENMODE, TRUE, 0);

	return 0;
}

BOOL APIENTRY DllMain( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
    HANDLE hThread;

    switch(ul_reason_for_call)
    {
    case DLL_PROCESS_ATTACH:

		{
			// ݒt@CꑫɓǂݍŁAEBhE[hĂB
			BOOL bFullScreen = LoadFullScreenMode();
			SaveFullScreenMode(FALSE);

			hThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) Main, (LPVOID)bFullScreen, 0, NULL);
			if(hThread == NULL)
			{
				return FALSE;
			}
			CloseHandle(hThread);
		}
		break;
    }
    return TRUE;
}